#!/bin/sh
# /usr/local/sbin/spamhaus
# 99% credit goes to BoneKracker, who posted the original scripts at
# https://forums.gentoo.org/viewtopic-p-7164238.html

#ipset_params="hash:net"
#target="http://list.iblocklist.com/?list=ydxerpxkpcfqjaybcssw&fileformat=cidr&archiveformat=gz&u$
#filename=$(basename ${target})
rm -r /tmp/blocklists
mkdir /tmp/blocklists



firewallipset=ET
minimumsize=5
USERNAME=your iblocklists username
PIN=your iblocklists pin
listsdir=/etc/p2p

firewallcidr=${firewallipset}cidr
firewallip=${firewallipset}ip

blocklistfile=/tmp/blocklists/$firewallipset
url="http://rules.emergingthreats.net/fwrules/emerging-Block-IPs.txt"


if ! ipset list -n|grep ${firewallcidr}; then ipset create ${firewallcidr} hash:net maxelem 4294967295; fi
if ! ipset list -n|grep ${firewallip}; then ipset create ${firewallip} hash:ip maxelem 4294967295; fi


wget -O $blocklistfile  "$url"

filesize=$(du -k ${blocklistfile} | cut -f 1)


# IF FILE OK RUN SCRIPT -   ELSE AT END LOG FAIL

if [ $filesize -ge $minimumsize ]; then
{
echo "STARTED on $(date)"> ${listsdir}/${firewallipset}.log
nice -n15 ipset -L ${firewallcidr} |head >> ${listsdir}/${firewallipset}.log
nice -n15 ipset -L ${firewallip} |head >> ${listsdir}/${firewallipset}.log

echo 3 > /proc/sys/vm/drop_caches
sleep 2
free >> $listsdir/$firewallipset.log
df -h >> $listsdir/$firewallipset.log

echo "create ${firewallcidr} hash:net maxelem 4294967295" >${blocklistfile}restore
echo "create ${firewallip} hash:ip maxelem 4294967295" >>${blocklistfile}restore


lines=$(wc -l "$blocklistfile"|cut -f1 -d" ")
currentline=0
 
exec < $blocklistfile
 
read line
while [ $currentline -lt $lines ]; do
  read line
  if echo "$line" | egrep -q "^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/[0-9]{2}$"; then
     echo "add "${firewallcidr}" "$line"" >>${blocklistfile}restore
	#ipset -q add ${firewallcidr} "$line"
  else
  if echo "$line" | egrep -q "^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$"; then
	echo "add "${firewallip}" "$line"" >>${blocklistfile}restore
	#ipset -q add ${firewallip} "$line"
  fi
  fi
  currentline=$(expr $currentline + 1)
done
 
rm $blocklistfile



# new blocklistfile holds restore data
mv ${blocklistfile}restore ${blocklistfile}


#bogons

#wget -O $blocklistfile "http://www.cidr-report.org/bogons/freespace-prefix.txt"

#for ipaddress in $(egrep -h -v -E "^#|^$" $blocklistfile); do
 #  ipset -q add $firewallcidr $ipaddress
#done

#  rm $blocklistfile





#Remove exclusions

cat $listsdir/excludelist | egrep -v '(^#|^\s*$)' | xargs -n 1 | sed 's/\(.*\)/del '"$firewallipset"' \1/' |>>${blocklistfile}
nice -n15 gzip ${blocklistfile}
mv ${blocklistfile}.gz $listsdir/


rm -f -r /tmp/blocklists

echo 3 > /proc/sys/vm/drop_caches
sleep 2
echo ------------------------------------------- >> ${listsdir}/${firewallipset}.log
df -h >> ${listsdir}/${firewallipset}.log
free >> ${listsdir}/${firewallipset}.log
echo "FINISHED on $(date)" >> ${listsdir}/${firewallipset}.log


ipset -F ${firewallcidr}
ipset -F ${firewallip}
zcat $listsdir/${firewallipset}.gz | nice -n15 ipset -! restore


nice -n15 ipset -L ${firewallcidr} |head >> ${listsdir}/${firewallipset}.log
nice -n15 ipset -L ${firewallip} |head >> ${listsdir}/${firewallipset}.log



logger "IPSET $firewallipset UPDATED on $(date)"
}


#if filesize less than, fail!
else
{
logger -p "----- IPSET $firewallipset NOT UPDATED ----- FILE TOO SMALL"
rm -f -r /tmp/blocklists
}
fi



