#!/bin/sh


rm -r /tmp/blocklists
mkdir /tmp/blocklists

firewallipset=L1
minimumsize=300
USERNAME=your iblocklists username
PIN=your iblocklists pin
listsdir=/etc/p2p

blocklistfile=/tmp/blocklists/$firewallipset

url="http://list.iblocklist.com/?list=ydxerpxkpcfqjaybcssw&fileformat=cidr&archiveformat=gz&username=$USERNAME&pin=$PIN"




wget -O "${blocklistfile}.gz" "$url"

filesize=$(du -k ${blocklistfile}.gz | cut -f 1)


# IF FILE OK RUN SCRIPT -   ELSE AT END LOG FAIL

if [ $filesize -ge $minimumsize ]; then
{
echo "STARTED on $(date)" > $listsdir/$firewallipset.log
nice -n15 ipset -L $firewallipset |head >> ${listsdir}/${firewallipset}.log

echo 3 > /proc/sys/vm/drop_caches
sleep 2
free >> $listsdir/$firewallipset.log
df -h >> $listsdir/$firewallipset.log

#rm $listsdir/${firewallipset}.gz
#touch $listsdir/${firewallipset}.gz

echo "create ${firewallipset} hash:net maxelem 4294967295" | gzip >${blocklistfile}restore.gz

gunzip -c "${blocklistfile}.gz" | egrep -v '(^#|^\s*$)' | xargs -n 1 |\
sed 's/\(.*\)/add '"$firewallipset"' \1/' | nice -n15 gzip >>${blocklistfile}restore.gz
rm ${blocklistfile}.gz

mv ${blocklistfile}restore.gz ${blocklistfile}.gz

#for ipaddress in $(egrep -h -v -E "^#|^$" $blocklistfile); do
#	printf "add "$firewallipset" $ipaddress" | gzip >>$listsdir/${firewallipset}.gz 
#   ipset -q add $firewallipset $ipaddress
#done

#Remove exclusions

cat $listsdir/excludelist | egrep -v '(^#|^\s*$)' | xargs -n 1 |\
 sed 's/\(.*\)/del '"$firewallipset"' \1/' | gzip >>${blocklistfile}.gz



#save file
#ipset save $firewallipset | nice -n15 gzip > ${blocklistfile}.gz


mv ${blocklistfile}.gz $listsdir/



rm -f -r /tmp/blocklists

echo 3 > /proc/sys/vm/drop_caches
sleep 2
echo ------------------------------------------- >> ${listsdir}/${firewallipset}.log
df -h >> ${listsdir}/${firewallipset}.log
free >> ${listsdir}/${firewallipset}.log
echo "FINISHED on $(date)" >> ${listsdir}/${firewallipset}.log


ipset -F $firewallipset


zcat $listsdir/${firewallipset}.gz | nice -n15 ipset -! restore


nice -n15 ipset -L $firewallipset |head >> ${listsdir}/${firewallipset}.log


logger "IPSET $firewallipset UPDATED on $(date)"
}


#if filesize less than, fail!
else
{ 
logger -p "----- IPSET $firewallipset NOT UPDATED ----- FILE TOO SMALL"
rm -f -r /tmp/blocklists
}
fi

